Loading...
Searching...
No Matches
casacore::LatticeBase Class Referenceabstract
lattices package (libcasa_lattices) » Lattices_module

More...

`#include <LatticeBase.h>`

## Public Member Functions

virtual | ~LatticeBase ()
| A virtual destructor is needed so that it will use the actual destructor in the derived class.
virtual LatticeBase * | clone () const =0
| Make a copy of the derived object (reference semantics).
virtual String | imageType () const
| Get the image type (returns name of derived class).
virtual DataType | dataType () const =0
| Get the data type of the lattice.
virtual Bool | isPersistent () const
| Is the lattice persistent and can it be loaded by other processes as well?
virtual Bool | isPaged () const
| Is the lattice paged to disk?
virtual Bool | canReferenceArray () const
| Can the lattice data be referenced as an array section?
virtual Bool | isWritable () const
| Is the lattice writable?
virtual void | save (const String &fileName) const
| Save the image in an AipsIO file with the given name.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| It is strongly recommended to use class LatticeLocker to handle lattice locking.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
| Resynchronize the Lattice object with the lattice file.
virtual void | flush ()
| Flush the data (but do not unlock).
virtual void | tempClose ()
| Temporarily close the lattice.
virtual void | reopen ()
| Explicitly reopen the temporarily closed lattice.
virtual String | name (Bool stripPath=False) const
| Return the name of the current Lattice object.
virtual IPosition | shape () const =0
| Return the shape of the Lattice including all degenerate axes (ie.
virtual uInt | ndim () const
| Return the number of axes in this Lattice.
virtual size_t | nelements () const
| Return the total number of elements in this Lattice.
size_t | size () const
Bool | conform (const LatticeBase &other) const
| Return a value of "True" if this instance of Lattice and 'other' have the same shape, otherwise returns a value of "False".
virtual LELCoordinates | lelCoordinates () const
| Return the coordinates of the lattice.
virtual uInt | advisedMaxPixels () const =0
| This function returns the recommended maximum number of pixels to include in the cursor of an iterator.
IPosition | niceCursorShape (uInt maxPixels) const
| Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
IPosition | niceCursorShape () const
virtual Bool | ok () const
| Check class internals - used for debugging.
virtual IPosition | doNiceCursorShape (uInt maxPixels) const
| The function (in the derived classes) doing the actual work.
virtual uInt | maximumCacheSize () const
| Maximum cache size - not necessarily all used.
virtual void | setMaximumCacheSize (uInt howManyPixels)
| Set the maximum (allowed) cache size as indicated.
virtual void | setCacheSizeInTiles (uInt howManyTiles)
| Set the actual cache size for this Array to be big enough for the indicated number of tiles.
virtual void | setCacheSizeFromPath (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath)
| Set the cache size as to "fit" the indicated path.
virtual void | clearCache ()
| Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.
virtual void | showCacheStatistics (ostream &os) const
| Report on cache success.

## Protected Member Functions

| LatticeBase ()
| Define default constructor to be used by derived classes.
| LatticeBase (const LatticeBase &)
| Copy constructor and assignment can only be used by derived classes.
LatticeBase & | operator= (const LatticeBase &)
void | throwBoolMath () const
| Throw an exception for arithmetic on a Bool Lattice.

## Detailed Description

A non-templated, abstract base class for array-like objects.

### Intended use:

Public interface

### Review Status

Reviewed By:
  Bob Garwood
Date Reviewed:
  2000/01/18
Test programs:
  tArrayLattice
Demo programs:
  dLattice

### Synopsis

This pure abstract base class defines the operations which may be performed on a lattice of any type.
See class Lattice for a detailed description of a lattice.

### Motivation

It is very useful to be able to keep a pointer to a non-templated base class. Furthermore it gives the opportunity to factor out some non-templated code.

Note: The cache functions (maximumCacheSize, setMaximumCacheSize, setCacheSizeInTiles, setCacheSizeFromPath, clearCache, and showCacheStatistics) should all be over-ridden together as in PagedArray;

Definition at line 78 of file LatticeBase.h.

## Constructor & Destructor Documentation

## ~LatticeBase()

virtual casacore::LatticeBase::~LatticeBase | ( |  | ) |

virtual

A virtual destructor is needed so that it will use the actual destructor in the derived class.

## LatticeBase() [1/2]

casacore::LatticeBase::LatticeBase | ( |  | ) |

inline protected

Define default constructor to be used by derived classes.

Definition at line 257 of file LatticeBase.h.

Referenced by clone(), conform(), casacore::Lattice< T >::Lattice(), LatticeBase(), and operator=().

## LatticeBase() [2/2]

casacore::LatticeBase::LatticeBase | ( | const LatticeBase & |  | ) |

inline protected

Copy constructor and assignment can only be used by derived classes.

Definition at line 261 of file LatticeBase.h.

References LatticeBase().

## Member Function Documentation

## advisedMaxPixels()

virtual uInt casacore::LatticeBase::advisedMaxPixels | ( |  | ) | const

pure virtual

This function returns the recommended maximum number of pixels to include in the cursor of an iterator.

The Lattice class has a default implementation which returns a number that is a power of two and includes enough pixels to consume between 4 and 8 MBytes of memory.

Implemented in casacore::ArrayLattice< T >, casacore::ArrayLattice< Bool >, casacore::CurvedImage2D< T >, casacore::CurvedLattice2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::FITSImage, casacore::FITSQualityImage, casacore::HDF5Image< T >, casacore::HDF5Lattice< T >, casacore::HDF5Lattice< Bool >, casacore::Lattice< T >, casacore::Lattice< Bool >, casacore::Lattice< Complex >, casacore::Lattice< DComplex >, casacore::Lattice< Double >, casacore::Lattice< Float >, casacore::LatticeRegion, casacore::LCHDF5Mask, casacore::LCMask, casacore::LCPagedMask, casacore::MIRIADImage, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::RebinLattice< T >, casacore::SubImage< T >, casacore::SubLattice< T >, casacore::TempImage< T >, casacore::TempLattice< T >, casacore::TempLattice< Complex >, casacore::TempLattice< Float >, and casacore::TempLattice< typename casacore::NumericTraits< T >::ConjugateType >.

Referenced by niceCursorShape().

## canReferenceArray()

virtual Bool casacore::LatticeBase::canReferenceArray | ( |  | ) | const

virtual

Can the lattice data be referenced as an array section?

That is the case for an ArrayLattice or a Temp/SubLattice using it. It is used by LatticeIterInterface.
The default implementation returns False.

Reimplemented in casacore::ArrayLattice< T >, casacore::ArrayLattice< Bool >, casacore::SubImage< T >, casacore::SubLattice< T >, casacore::TempImage< T >, casacore::TempLattice< T >, casacore::TempLattice< Complex >, casacore::TempLattice< Float >, and casacore::TempLattice< typename casacore::NumericTraits< T >::ConjugateType >.

## clearCache()

virtual void casacore::LatticeBase::clearCache | ( |  | ) |

virtual

Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.

The default implementation does nothing.

Reimplemented in casacore::FITSImage, casacore::FITSQualityImage, casacore::LatticeRegion, casacore::LCMask, casacore::LCPagedMask, casacore::MIRIADImage, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::TempImage< T >, casacore::TempLattice< T >, casacore::TempLattice< Complex >, casacore::TempLattice< Float >, and casacore::TempLattice< typename casacore::NumericTraits< T >::ConjugateType >.

## clone()

virtual LatticeBase * casacore::LatticeBase::clone | ( |  | ) | const

pure virtual

Make a copy of the derived object (reference semantics).

Implemented in casacore::ArrayLattice< T >, casacore::ArrayLattice< Bool >, casacore::FITSMask, casacore::FITSQualityMask, casacore::HDF5Lattice< T >, casacore::HDF5Lattice< Bool >, casacore::Lattice< T >, casacore::Lattice< Bool >, casacore::Lattice< Complex >, casacore::Lattice< DComplex >, casacore::Lattice< Double >, casacore::Lattice< Float >, casacore::LatticeRegion, casacore::LCRegion, casacore::MaskedLattice< T >, casacore::MaskedLattice< Bool >, casacore::MaskedLattice< Complex >, casacore::MaskedLattice< DComplex >, casacore::MaskedLattice< Double >, casacore::MaskedLattice< Float >, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::TempLattice< T >, casacore::TempLattice< Complex >, casacore::TempLattice< Float >, and casacore::TempLattice< typename casacore::NumericTraits< T >::ConjugateType >.

References LatticeBase().

## conform()

Bool casacore::LatticeBase::conform | ( | const LatticeBase & | other | ) | const

inline

Return a value of "True" if this instance of Lattice and 'other' have the same shape, otherwise returns a value of "False".

Definition at line 181 of file LatticeBase.h.

References casacore::IPosition::isEqual(), LatticeBase(), and shape().

## dataType()

virtual DataType casacore::LatticeBase::dataType | ( |  | ) | const

pure virtual

Get the data type of the lattice.

Implemented in casacore::FITSImage, casacore::FITSQualityImage, casacore::Lattice< T >, casacore::Lattice< Bool >, casacore::Lattice< Complex >, casacore::Lattice< DComplex >, casacore::Lattice< Double >, casacore::Lattice< Float >, and casacore::MIRIADImage.

## doNiceCursorShape()

virtual IPosition casacore::LatticeBase::doNiceCursorShape | ( | uInt | maxPixels | ) | const

virtual

The function (in the derived classes) doing the actual work.

This function is public, so it can be used internally in the various Lattice classes.
The default implementation tries to fit as many axes as possible given maxPixels.

Reimplemented in casacore::CurvedImage2D< T >, casacore::CurvedLattice2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::FITSImage, casacore::FITSQualityImage, casacore::HDF5Image< T >, casacore::HDF5Lattice< T >, casacore::HDF5Lattice< Bool >, casacore::ImageConcat< T >, casacore::ImageExpr< T >, casacore::ImageExpr< Bool >, casacore::LatticeConcat< T >, casacore::LatticeExpr< T >, casacore::LatticeExpr< Bool >, casacore::LatticeRegion, casacore::LCConcatenation, casacore::LCExtension, casacore::LCHDF5Mask, casacore::LCMask, casacore::LCPagedMask, casacore::LCRegionMulti, casacore::LCRegionSingle, casacore::LCStretch, casacore::MIRIADImage, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::SubImage< T >, casacore::SubLattice< T >, casacore::TempImage< T >, casacore::TempLattice< T >, casacore::TempLattice< Complex >, casacore::TempLattice< Float >, and casacore::TempLattice< typename casacore::NumericTraits< T >::ConjugateType >.

Referenced by niceCursorShape(), and niceCursorShape().

## flush()

virtual void casacore::LatticeBase::flush | ( |  | ) |

virtual

Flush the data (but do not unlock).

By default the function does not do anything at all.

Reimplemented in casacore::CurvedImage2D< T >, casacore::CurvedLattice2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::HDF5Image< T >, casacore::HDF5Lattice< T >, casacore::HDF5Lattice< Bool >, casacore::ImageConcat< T >, casacore::LatticeConcat< T >, casacore::LatticeRegion, casacore::LCHDF5Mask, casacore::LCMask, casacore::LCPagedMask, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::RebinLattice< T >, casacore::SubImage< T >, casacore::SubLattice< T >, casacore::TempImage< T >, casacore::TempLattice< T >, casacore::TempLattice< Complex >, casacore::TempLattice< Float >, and casacore::TempLattice< typename casacore::NumericTraits< T >::ConjugateType >.

## hasLock()

virtual Bool casacore::LatticeBase::hasLock | ( | FileLocker::LockType |  | ) | const

virtual

Reimplemented in casacore::CurvedImage2D< T >, casacore::CurvedLattice2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::ImageConcat< T >, casacore::ImageExpr< T >, casacore::ImageExpr< Bool >, casacore::LatticeConcat< T >, casacore::LatticeExpr< T >, casacore::LatticeExpr< Bool >, casacore::LatticeRegion, casacore::LCLELMask, casacore::LCMask, casacore::LCPagedMask, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::RebinLattice< T >, casacore::SubImage< T >, and casacore::SubLattice< T >.

## imageType()

virtual String casacore::LatticeBase::imageType | ( |  | ) | const

virtual

Get the image type (returns name of derived class).

The default implementation returns "Lattice". Note it is made pure virtual in ImageInterface.

Reimplemented in casacore::CurvedImage2D< T >, casacore::ExtendImage< T >, casacore::FITSErrorImage, casacore::FITSImage, casacore::FITSQualityImage, casacore::HDF5Image< T >, casacore::ImageConcat< T >, casacore::ImageExpr< T >, casacore::ImageExpr< Bool >, casacore::ImageInterface< T >, casacore::ImageInterface< Bool >, casacore::ImageInterface< Complex >, casacore::ImageInterface< DComplex >, casacore::ImageInterface< Double >, casacore::ImageInterface< Float >, casacore::MIRIADImage, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::SubImage< T >, and casacore::TempImage< T >.

## isPaged()

virtual Bool casacore::LatticeBase::isPaged | ( |  | ) | const

virtual

Is the lattice paged to disk?

The default implementation returns False.

Reimplemented in casacore::CurvedImage2D< T >, casacore::CurvedLattice2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::FITSImage, casacore::FITSQualityImage, casacore::HDF5Image< T >, casacore::HDF5Lattice< T >, casacore::HDF5Lattice< Bool >, casacore::MIRIADImage, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::RebinLattice< T >, casacore::SubImage< T >, casacore::SubLattice< T >, casacore::TempImage< T >, casacore::TempLattice< T >, casacore::TempLattice< Complex >, casacore::TempLattice< Float >, and casacore::TempLattice< typename casacore::NumericTraits< T >::ConjugateType >.

## isPersistent()

virtual Bool casacore::LatticeBase::isPersistent | ( |  | ) | const

virtual

Is the lattice persistent and can it be loaded by other processes as well?

That is the case for a PagedArray or PagedImage and for an ImageExpr which does not use transient lattices or regions.
The default implementation returns False.

Reimplemented in casacore::CurvedImage2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::FITSImage, casacore::FITSQualityImage, casacore::HDF5Image< T >, casacore::HDF5Lattice< T >, casacore::HDF5Lattice< Bool >, casacore::ImageConcat< T >, casacore::ImageExpr< T >, casacore::ImageExpr< Bool >, casacore::MIRIADImage, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::SubImage< T >, and casacore::SubLattice< T >.

## isWritable()

virtual Bool casacore::LatticeBase::isWritable | ( |  | ) | const

virtual

Is the lattice writable?

The default implementation returns True.

Reimplemented in casacore::ArrayLattice< T >, casacore::ArrayLattice< Bool >, casacore::CurvedImage2D< T >, casacore::CurvedLattice2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::FITSImage, casacore::FITSMask, casacore::FITSQualityImage, casacore::FITSQualityMask, casacore::HDF5Image< T >, casacore::HDF5Lattice< T >, casacore::HDF5Lattice< Bool >, casacore::ImageConcat< T >, casacore::ImageExpr< T >, casacore::ImageExpr< Bool >, casacore::LatticeConcat< T >, casacore::LatticeExpr< T >, casacore::LatticeExpr< Bool >, casacore::LatticeRegion, casacore::LCHDF5Mask, casacore::LCMask, casacore::LCPagedMask, casacore::LCRegion, casacore::MIRIADImage, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::RebinLattice< T >, casacore::SubImage< T >, casacore::SubLattice< T >, casacore::TempImage< T >, casacore::TempLattice< T >, casacore::TempLattice< Complex >, casacore::TempLattice< Float >, and casacore::TempLattice< typename casacore::NumericTraits< T >::ConjugateType >.

## lelCoordinates()

virtual LELCoordinates casacore::LatticeBase::lelCoordinates | ( |  | ) | const

virtual

Return the coordinates of the lattice.

The default implementation returns an 'empty' LELLattCoord object.

Reimplemented in casacore::ImageInterface< T >, casacore::ImageInterface< Bool >, casacore::ImageInterface< Complex >, casacore::ImageInterface< DComplex >, casacore::ImageInterface< Double >, casacore::ImageInterface< Float >, casacore::LatticeExpr< T >, and casacore::LatticeExpr< Bool >.

## lock()

virtual Bool casacore::LatticeBase::lock | ( | FileLocker::LockType | ,
|  | uInt | nattempts )

virtual

It is strongly recommended to use class LatticeLocker to handle lattice locking.

It also contains a more detailed explanation of the locking process.
By default the functions do not do anything at all. lock() and hasLock return True, which is suitable for all non-paged lattices.

Reimplemented in casacore::CurvedImage2D< T >, casacore::CurvedLattice2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::ImageConcat< T >, casacore::ImageExpr< T >, casacore::ImageExpr< Bool >, casacore::LatticeConcat< T >, casacore::LatticeExpr< T >, casacore::LatticeExpr< Bool >, casacore::LatticeRegion, casacore::LCLELMask, casacore::LCMask, casacore::LCPagedMask, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::RebinLattice< T >, casacore::SubImage< T >, and casacore::SubLattice< T >.

## maximumCacheSize()

virtual uInt casacore::LatticeBase::maximumCacheSize | ( |  | ) | const

virtual

Maximum cache size - not necessarily all used.

In pixels. Default returns 0, which means that there is no maximum.

Reimplemented in casacore::FITSImage, casacore::FITSQualityImage, casacore::LatticeRegion, casacore::LCMask, casacore::LCPagedMask, casacore::MIRIADImage, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::TempImage< T >, casacore::TempLattice< T >, casacore::TempLattice< Complex >, casacore::TempLattice< Float >, and casacore::TempLattice< typename casacore::NumericTraits< T >::ConjugateType >.

## name()

virtual String casacore::LatticeBase::name | ( | Bool | stripPath = False | ) | const

virtual

Return the name of the current Lattice object.

This will generally be a file name for lattices that have a persistent form. Any path before the actual file name can be optionally stripped off.
The default implementation returns an empty string.

Reimplemented in casacore::CurvedImage2D< T >, casacore::CurvedLattice2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::FITSImage, casacore::FITSQualityImage, casacore::HDF5Image< T >, casacore::HDF5Lattice< T >, casacore::HDF5Lattice< Bool >, casacore::ImageConcat< T >, casacore::ImageExpr< T >, casacore::ImageExpr< Bool >, casacore::ImageInterface< T >, casacore::ImageInterface< Bool >, casacore::ImageInterface< Complex >, casacore::ImageInterface< DComplex >, casacore::ImageInterface< Double >, casacore::ImageInterface< Float >, casacore::LatticeConcat< T >, casacore::MIRIADImage, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::RebinLattice< T >, casacore::SubImage< T >, casacore::SubLattice< T >, and casacore::TempImage< T >.

References casacore::False.

## ndim()

virtual uInt casacore::LatticeBase::ndim | ( |  | ) | const

virtual

Return the number of axes in this Lattice.

This includes all degenerate axes.
The default implementation returns shape().nelements().

Reimplemented in casacore::LatticeRegion, casacore::LCRegion, and casacore::SubImage< T >.

## nelements()

virtual size_t casacore::LatticeBase::nelements | ( |  | ) | const

virtual

Return the total number of elements in this Lattice.

The default implementation returns shape().product().

Reimplemented in casacore::LatticeRegion, and casacore::SubImage< T >.

Referenced by size().

## niceCursorShape() [1/2]

IPosition casacore::LatticeBase::niceCursorShape | ( |  | ) | const

inline

Definition at line 208 of file LatticeBase.h.

References advisedMaxPixels(), and doNiceCursorShape().

## niceCursorShape() [2/2]

IPosition casacore::LatticeBase::niceCursorShape | ( | uInt | maxPixels | ) | const

inline

Returns a recommended cursor shape for iterating through all the pixels in the Lattice.

The default implementation sets up a shape that completely fills as many axes as possible, but always at least the first axis. For example, given a 10x20x30 Lattice

maxPixels = 1 --> niceCursorShape = [10,1,1]
100 --> niceCursorShape = [10,1,1]
300 --> niceCursorShape = [10,20,1]
10000 --> niceCursorShape = [10,20,30]
casacore::LatticeBase::niceCursorShape
IPosition niceCursorShape(uInt maxPixels) const
Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
Definition LatticeBase.h:206

The default argument is the result of advisedMaxPixels().

Definition at line 206 of file LatticeBase.h.

References doNiceCursorShape().

## ok()

virtual Bool casacore::LatticeBase::ok | ( |  | ) | const

virtual

Check class internals - used for debugging.

Should always return True

Reimplemented in casacore::ArrayLattice< T >, casacore::ArrayLattice< Bool >, casacore::CurvedImage2D< T >, casacore::CurvedLattice2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::FITSImage, casacore::FITSQualityImage, casacore::HDF5Image< T >, casacore::HDF5Lattice< T >, casacore::HDF5Lattice< Bool >, casacore::ImageConcat< T >, casacore::ImageExpr< T >, casacore::ImageExpr< Bool >, casacore::ImageInterface< T >, casacore::ImageInterface< Bool >, casacore::ImageInterface< Complex >, casacore::ImageInterface< DComplex >, casacore::ImageInterface< Double >, casacore::ImageInterface< Float >, casacore::LatticeRegion, casacore::MIRIADImage, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::RebinLattice< T >, casacore::SubImage< T >, casacore::SubLattice< T >, casacore::TempImage< T >, casacore::TempLattice< T >, casacore::TempLattice< Complex >, casacore::TempLattice< Float >, and casacore::TempLattice< typename casacore::NumericTraits< T >::ConjugateType >.

## operator=()

LatticeBase & casacore::LatticeBase::operator= | ( | const LatticeBase & |  | ) |

inline protected

Definition at line 262 of file LatticeBase.h.

References LatticeBase().

## reopen()

virtual void casacore::LatticeBase::reopen | ( |  | ) |

virtual

Explicitly reopen the temporarily closed lattice.

By default the function does not do anything at all.

Reimplemented in casacore::CurvedImage2D< T >, casacore::CurvedLattice2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::FITSImage, casacore::FITSQualityImage, casacore::ImageConcat< T >, casacore::ImageExpr< T >, casacore::ImageExpr< Bool >, casacore::LatticeConcat< T >, casacore::LatticeRegion, casacore::LCLELMask, casacore::LCMask, casacore::LCPagedMask, casacore::MIRIADImage, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::RebinLattice< T >, casacore::SubImage< T >, casacore::SubLattice< T >, casacore::TempImage< T >, casacore::TempLattice< T >, casacore::TempLattice< Complex >, casacore::TempLattice< Float >, and casacore::TempLattice< typename casacore::NumericTraits< T >::ConjugateType >.

## resync()

virtual void casacore::LatticeBase::resync | ( |  | ) |

virtual

Resynchronize the Lattice object with the lattice file.

This function is only useful if no read-locking is used, ie. if the table lock option is UserNoReadLocking or AutoNoReadLocking. In that cases the table system does not acquire a read-lock, thus does not synchronize itself automatically.
By default the function does not do anything at all.

Reimplemented in casacore::CurvedImage2D< T >, casacore::CurvedLattice2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::ImageConcat< T >, casacore::ImageExpr< T >, casacore::ImageExpr< Bool >, casacore::LatticeConcat< T >, casacore::LatticeExpr< T >, casacore::LatticeExpr< Bool >, casacore::LatticeRegion, casacore::LCLELMask, casacore::LCMask, casacore::LCPagedMask, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::RebinLattice< T >, casacore::SubImage< T >, and casacore::SubLattice< T >.

## save()

virtual void casacore::LatticeBase::save | ( | const String & | fileName | ) | const

virtual

Save the image in an AipsIO file with the given name.

Its purpose is to make ImageConcat and ImageExpr objects persistent.
The default implementation throws an exception.

Reimplemented in casacore::ImageConcat< T >, casacore::ImageExpr< T >, and casacore::ImageExpr< Bool >.

## setCacheSizeFromPath()

virtual void casacore::LatticeBase::setCacheSizeFromPath | ( | const IPosition & | sliceShape,
|  | const IPosition & | windowStart,
|  | const IPosition & | windowLength,
|  | const IPosition & | axisPath )

virtual

Set the cache size as to "fit" the indicated path.

The default implementation does nothing.

Reimplemented in casacore::FITSImage, casacore::FITSQualityImage, casacore::HDF5Lattice< T >, casacore::HDF5Lattice< Bool >, casacore::LatticeRegion, casacore::LCMask, casacore::LCPagedMask, casacore::MIRIADImage, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::TempImage< T >, casacore::TempLattice< T >, casacore::TempLattice< Complex >, casacore::TempLattice< Float >, and casacore::TempLattice< typename casacore::NumericTraits< T >::ConjugateType >.

## setCacheSizeInTiles()

virtual void casacore::LatticeBase::setCacheSizeInTiles | ( | uInt | howManyTiles | ) |

virtual

Set the actual cache size for this Array to be big enough for the indicated number of tiles.

This cache is not shared with PagedArrays in other rows and is always clipped to be less than the maximum value set using the setMaximumCacheSize member function. Tiles are cached using a first in first out algorithm.
The default implementation does nothing.

Reimplemented in casacore::FITSImage, casacore::FITSQualityImage, casacore::HDF5Lattice< T >, casacore::HDF5Lattice< Bool >, casacore::LatticeRegion, casacore::LCMask, casacore::LCPagedMask, casacore::MIRIADImage, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::TempImage< T >, casacore::TempLattice< T >, casacore::TempLattice< Complex >, casacore::TempLattice< Float >, and casacore::TempLattice< typename casacore::NumericTraits< T >::ConjugateType >.

## setMaximumCacheSize()

virtual void casacore::LatticeBase::setMaximumCacheSize | ( | uInt | howManyPixels | ) |

virtual

Set the maximum (allowed) cache size as indicated.

The default implementation does nothing.

Reimplemented in casacore::FITSImage, casacore::FITSQualityImage, casacore::LatticeRegion, casacore::LCMask, casacore::LCPagedMask, casacore::MIRIADImage, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::TempImage< T >, casacore::TempLattice< T >, casacore::TempLattice< Complex >, casacore::TempLattice< Float >, and casacore::TempLattice< typename casacore::NumericTraits< T >::ConjugateType >.

## shape()

virtual IPosition casacore::LatticeBase::shape | ( |  | ) | const

pure virtual

Return the shape of the Lattice including all degenerate axes (ie.

axes with a length of one)

Implemented in casacore::ArrayLattice< T >, casacore::ArrayLattice< Bool >, casacore::CurvedImage2D< T >, casacore::CurvedLattice2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::FITSImage, casacore::FITSMask, casacore::FITSQualityImage, casacore::FITSQualityMask, casacore::HDF5Image< T >, casacore::HDF5Lattice< T >, casacore::HDF5Lattice< Bool >, casacore::ImageConcat< T >, casacore::ImageExpr< T >, casacore::ImageExpr< Bool >, casacore::LatticeConcat< T >, casacore::LatticeExpr< T >, casacore::LatticeExpr< Bool >, casacore::LatticeRegion, casacore::LCRegion, casacore::MIRIADImage, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::RebinLattice< T >, casacore::SubImage< T >, casacore::SubLattice< T >, casacore::TempImage< T >, casacore::TempLattice< T >, casacore::TempLattice< Complex >, casacore::TempLattice< Float >, and casacore::TempLattice< typename casacore::NumericTraits< T >::ConjugateType >.

Referenced by conform(), casacore::Lattice< T >::getSlice(), casacore::Lattice< T >::getSlice(), casacore::Lattice< T >::getSlice(), casacore::Lattice< T >::getSlice(), casacore::Lattice< T >::getSlice(), and casacore::Lattice< T >::getSlice().

## showCacheStatistics()

virtual void casacore::LatticeBase::showCacheStatistics | ( | ostream & | os | ) | const

virtual

Report on cache success.

The default implementation does nothing.

Reimplemented in casacore::FITSImage, casacore::FITSQualityImage, casacore::LatticeRegion, casacore::LCMask, casacore::LCPagedMask, casacore::MIRIADImage, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::TempImage< T >, casacore::TempLattice< T >, casacore::TempLattice< Complex >, casacore::TempLattice< Float >, and casacore::TempLattice< typename casacore::NumericTraits< T >::ConjugateType >.

## size()

size_t casacore::LatticeBase::size | ( |  | ) | const

inline

Definition at line 175 of file LatticeBase.h.

References nelements().

## tempClose()

virtual void casacore::LatticeBase::tempClose | ( |  | ) |

virtual

Temporarily close the lattice.

It will be reopened automatically on the next access.
By default the function does not do anything at all.

Reimplemented in casacore::CurvedImage2D< T >, casacore::CurvedLattice2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::FITSImage, casacore::FITSQualityImage, casacore::ImageConcat< T >, casacore::ImageExpr< T >, casacore::ImageExpr< Bool >, casacore::LatticeConcat< T >, casacore::LatticeRegion, casacore::LCLELMask, casacore::LCMask, casacore::LCPagedMask, casacore::MIRIADImage, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::RebinLattice< T >, casacore::SubImage< T >, casacore::SubLattice< T >, casacore::TempImage< T >, casacore::TempLattice< T >, casacore::TempLattice< Complex >, casacore::TempLattice< Float >, and casacore::TempLattice< typename casacore::NumericTraits< T >::ConjugateType >.

## throwBoolMath()

void casacore::LatticeBase::throwBoolMath | ( |  | ) | const

protected

Throw an exception for arithmetic on a Bool Lattice.

Referenced by casacore::Lattice< Float >::handleMathTo(), and casacore::LatticeExpr< Bool >::handleMathTo().

## unlock()

virtual void casacore::LatticeBase::unlock | ( |  | ) |

virtual

Reimplemented in casacore::CurvedImage2D< T >, casacore::CurvedLattice2D< T >, casacore::ExtendImage< T >, casacore::ExtendLattice< T >, casacore::ImageConcat< T >, casacore::ImageExpr< T >, casacore::ImageExpr< Bool >, casacore::LatticeConcat< T >, casacore::LatticeExpr< T >, casacore::LatticeExpr< Bool >, casacore::LatticeRegion, casacore::LCLELMask, casacore::LCMask, casacore::LCPagedMask, casacore::PagedArray< T >, casacore::PagedArray< Bool >, casacore::PagedImage< T >, casacore::RebinImage< T >, casacore::RebinLattice< T >, casacore::SubImage< T >, and casacore::SubLattice< T >.

The documentation for this class was generated from the following file:

- lattices/Lattices/LatticeBase.h